VERSION 5.00
Begin VB.Form frmReceive 
   Caption         =   "Oh, I love Getting Messages"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox lstMessages 
      Height          =   2985
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4455
   End
End
Attribute VB_Name = "frmReceive"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==========================================================
'   Compuware, NuMega Lab
'
'   Microsoft Windows DNA 2000
'   'Under the Hood' Series
'
'   'Using MSMQ in a Distributed Application'
'
'==========================================================
Option Explicit

Private WithEvents qevtRecEvents As MSMQEvent
Attribute qevtRecEvents.VB_VarHelpID = -1

Private m_oRequestQueueInfo     As MSMQQueueInfo
Private m_oRequestQueue         As MSMQQueue

Private Sub Form_Load()
    Dim oQueueInfo As MSMQQueueInfo
    
    '   Create the test queue
    '   This queue must match the one crteated by our sending application
    Set m_oRequestQueueInfo = CreateMSMQQueue(".\vbcRequestQueue", "Send to Queue")
    Set m_oRequestQueue = m_oRequestQueueInfo.Open(Access:=MQ_RECEIVE_ACCESS, ShareMode:=MQ_DENY_RECEIVE_SHARE)

    Set qevtRecEvents = New MSMQEvent
    m_oRequestQueue.EnableNotification qevtRecEvents

End Sub

Private Sub qevtRecEvents_Arrived(ByVal Queue As Object, ByVal Cursor As Long)
    ' Getting here means that we have received  mnessage
    Dim oMsg        As MSMQMessage
    Dim oRespQueue  As MSMQQueue
    Dim oRespMsg    As MSMQMessage
  
    Set oMsg = Queue.Receive(ReceiveTimeout:=0)
  
    If Not oMsg Is Nothing Then
        '   in the real world you would process the message here
        lstMessages.AddItem "We got a message: " & oMsg.Label
        lstMessages.Refresh
        
        '   Let's check to see if there is arequest queue that we need to send to
        If Not oMsg.ResponseQueueInfo Is Nothing Then
            Set oRespQueue = oMsg.ResponseQueueInfo.Open(MQ_SEND_ACCESS, MQ_DENY_NONE)
            
            Set oRespMsg = New MSMQMessage
            
            oRespMsg.Label = "Response for: " & oMsg.Label
            oRespMsg.Body = "Received your message and processing is complete"
            oRespMsg.CorrelationId = oMsg.Id
            oRespMsg.Journal = MQMSG_JOURNAL
            oRespMsg.Send oRespQueue
            
        End If
    End If
  
    '   Reset the notification for the queue
    Queue.EnableNotification qevtRecEvents

End Sub


