Attribute VB_Name = "General"
'==========================================================
'   Compuware, NuMega Lab
'
'   Microsoft Windows DNA 2000
'   'Under the Hood' Series
'
'   'Using MSMQ in a Distributed Application'
'
'==========================================================
Option Explicit

Public Function CreateMSMQQueue(strPathName As String, strLabel As String, Optional bIsTransactionable As Boolean = False, Optional strGUID As String = "") As MSMQQueueInfo
    Dim oQueueInfo As New MSMQQueueInfo
    
    ' If the queue already exists, ignore the error
    On Error Resume Next
    
    oQueueInfo.PathName = strPathName
    oQueueInfo.Label = strLabel
    
    If Len(strGUID) > 0 Then
        oQueueInfo.ServiceTypeGuid = strGUID
    End If

    oQueueInfo.Create IsTransactional:=bIsTransactionable, IsWorldReadable:=True

    Set CreateMSMQQueue = oQueueInfo
End Function

