VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Complex Messages"
   ClientHeight    =   3900
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3555
   LinkTopic       =   "Form1"
   ScaleHeight     =   3900
   ScaleWidth      =   3555
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRecordset 
      Caption         =   "Send Recordset Data"
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   1920
      Width           =   3255
   End
   Begin VB.TextBox txtISBN 
      Height          =   285
      Left            =   120
      TabIndex        =   5
      Text            =   "0-201-70712-8"
      Top             =   3480
      Width           =   3255
   End
   Begin VB.TextBox txtAuthor 
      Height          =   285
      Left            =   120
      TabIndex        =   4
      Text            =   "Matt Curland"
      Top             =   3120
      Width           =   3255
   End
   Begin VB.TextBox txtTitle 
      Height          =   285
      Left            =   120
      TabIndex        =   3
      Text            =   "Advanced Visual Basic 6.0"
      Top             =   2760
      Width           =   3255
   End
   Begin VB.CommandButton cmdByte 
      Caption         =   "Send Byte Array Data"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   3255
   End
   Begin VB.CommandButton cmdPropBag 
      Caption         =   "Send Property Bag Data"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   3255
   End
   Begin VB.CommandButton cmdPersistant 
      Caption         =   "Send Persistant Class Data"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'==========================================================
'   Compuware, NuMega Lab
'
'   Microsoft Windows DNA 2000
'   'Under the Hood' Series
'
'   'Using MSMQ in a Distributed Application'
'
'==========================================================
Option Explicit

Private m_oRequestQueueInfo     As MSMQQueueInfo
Private m_oRequestQueue         As MSMQQueue

Private Sub cmdByte_Click()
    Dim bytArray()  As Byte
    Dim lSize       As Long
    Dim strData     As String
    
    lSize = Len(txtTitle.Text) + Len(txtAuthor.Text) + Len(txtISBN.Text) + 4
    strData = txtTitle.Text & Chr$(0) & txtAuthor.Text & Chr$(0) & txtISBN.Text & Chr$(0) & Chr$(0)
    bytArray = strData

    '   create a MSMQMEssage object and fill it up
    Dim oMsg    As New MSMQMessage
    
    oMsg.Body = bytArray
    oMsg.Label = "Message to demonstrate Passing Byte Arrays (1)"
    oMsg.Send m_oRequestQueue

    Dim bytArray2(0 To 8)   As Byte
    
    bytArray2(0) = 27
    bytArray2(1) = 65
    bytArray2(2) = 105
    bytArray2(3) = 254
    bytArray2(4) = 45
    bytArray2(5) = 66
    bytArray2(6) = 77
    bytArray2(7) = 0
    bytArray2(8) = 1

    oMsg.Body = bytArray2
    oMsg.Label = "Message to demonstrate Passing Byte Arrays (2)"
    oMsg.Send m_oRequestQueue

End Sub

Private Sub cmdPersistant_Click()
    Dim oBook As New CBook
    
    '   assign values to our CBook object
    oBook.m_strTitle = txtTitle.Text
    oBook.m_strAuthor = txtAuthor.Text
    oBook.m_ISDN = txtISBN.Text
    
    '   create a MSMQMEssage object and fill it up
    Dim oMsg    As New MSMQMessage
    
    oMsg.Body = oBook
    oMsg.Label = "Message to demonstrate Passing Persistant Classes"
    oMsg.Send m_oRequestQueue
    
End Sub

Private Sub cmdPropBag_Click()
    Dim oPropBag As New PropertyBag
    
    '   fill up the property bag
    oPropBag.WriteProperty "Title", txtTitle.Text
    oPropBag.WriteProperty "Author", txtAuthor.Text
    oPropBag.WriteProperty "ISBN", txtISBN.Text
    
    '   create a MSMQMEssage object and fill it up
    Dim oMsg    As New MSMQMessage
    
    oMsg.Body = oPropBag.Contents
    oMsg.Label = "Message to demonstrate Passing PropertyBag Data"
    oMsg.Send m_oRequestQueue

End Sub

Private Sub cmdRecordset_Click()
    '   create a recodset on the fly
    '   You could of course use a real recordset returned from a SQL query
    Dim rsNew   As New Recordset
    
    rsNew.Fields.Append "Title", adBSTR, -1
    rsNew.Fields.Append "Author", adBSTR, -1
    rsNew.Fields.Append "ISBN", adBSTR, -1
    rsNew.Open
    
    rsNew.AddNew
    rsNew("Title").Value = txtTitle.Text
    rsNew("Author").Value = txtAuthor.Text
    rsNew("ISBN").Value = txtISBN.Text
    rsNew.Update
    
    '   create a MSMQMEssage object and fill it up
    Dim oMsg    As New MSMQMessage
    
    oMsg.Body = rsNew
    oMsg.Label = "Message to demonstrate Passing Recordset Data"
    oMsg.Send m_oRequestQueue
    
    rsNew.Close
    Set rsNew = Nothing
End Sub

Private Sub Form_Load()
    '  Create the test queue
    Set m_oRequestQueueInfo = CreateMSMQQueue(".\vbcComplexMessageQueue", "")
    Set m_oRequestQueue = m_oRequestQueueInfo.Open(Access:=MQ_SEND_ACCESS, ShareMode:=MQ_DENY_NONE)

End Sub

Private Sub Form_Unload(Cancel As Integer)
    m_oRequestQueue.Close
End Sub
